#ifndef __LCD__
#define __LCD__

#include <AT89X51.H>
#include <INTRINS.H>

/*----------------------------------------------------
****** port and bit assignment for LCD *******
----------------------------------------------------*/

typedef unsigned char bit_8;

#define lcd_port P1
sbit rs=P3^5;					// register select is port 3.5
sbit rw=P3^4;					// read/write is port 3.4
sbit en=P3^3;					// enable is port 3.3
sbit d7=P1^7;					// busy flag is port 1.7
sbit sel_param=P3^2;			// select switch to select the clock parameter
sbit chg_param_inc=P3^1;		// change switch to change the clock parameter
sbit chg_param_dec=P3^0;

/*-------------------------
*** Function Prototypes ***
-------------------------*/

void ini(void);
void command(bit_8);
void data_in(bit_8*);
void busy(void);
void sec1(void);
void month_select(bit_8);
void date_in(bit_8);
void lcd_data(bit_8);
void set_clock();
void delay(void); 
void cgrambuild(void);
void bdata_in(bit_8, bit_8);
void big_data_in(bit_8, bit_8);
void lcd_zero(bit_8);
void lcd_one(bit_8);
void lcd_two(bit_8);
void lcd_three(bit_8);
void lcd_four(bit_8);
void lcd_five(bit_8);
void lcd_six(bit_8);
void lcd_seven(bit_8);
void lcd_eight(bit_8);
void lcd_nine(bit_8);

/*-----------------
*** some macros ***
-----------------*/

#define DISABLE_INT IE=0x0;
#define ENABLE_INT IE=0x81;

#endif